; -- Example1.iss --
; Demonstrates copying 3 files and creating an icon.

; SEE THE DOCUMENTATION FOR DETAILS ON CREATING .ISS SCRIPT FILES!
[Setup]
DisableWelcomePage=False
ShowLanguageDialog=yes
ShowUndisplayableLanguages=yes

AppName=My Program
AppVersion=1.5
WizardStyle=modern
DefaultDirName={autopf}\My Program
DefaultGroupName=My Program
UninstallDisplayIcon={app}\MyProg.exe
Compression=lzma2
SolidCompression=yes
OutputDir=userdocs:Inno Setup Examples Output

[Languages]
Name: "English"; MessagesFile: "compiler:Default.isl"
Name: "French"; MessagesFile: "compiler:Languages\French.isl"
Name: "German"; MessagesFile: "compiler:Languages\German.isl"
Name: "Spanish"; MessagesFile: "compiler:Languages\Spanish.isl"
Name: "Thai"; MessagesFile: "compiler:Languages\Thai.isl"
//Add languages as you like ...


[Code]
var
  LangCombo: TNewComboBox;
  SelectLangLabel: TNewStaticText;
  LangArray: Array of String;
  IsConfirm: Boolean;

function ShellExecute(hwnd: HWND; lpOperation, lpFile, lpParameters, lpDirectory: String; nShowCmd: Integer): THandle;
external 'ShellExecuteW@shell32.dll stdcall';

function IsSetLang: Boolean;
begin
  Result := (ExpandConstant('{param:LANG}') = '');
end;

function IsActiveLang: Boolean;
begin
  Result := (LangArray[LangCombo.ItemIndex] = ActiveLanguage);
end;

function ActiveLang: Integer;
var
  I: Integer;
begin
  for I := 0 to (GetArrayLength(LangArray) - 1) do
  begin
    if (LangArray[I] = ActiveLanguage) then Result := I;
  end;
end;

procedure InitializeWizard;
begin
  IsConfirm := True;

  LangCombo := TNewComboBox.Create(WizardForm);
  LangCombo.Parent := WizardForm.WelcomePage;
  LangCombo.Top := WizardForm.Bevel.Top - LangCombo.Height - ScaleY(55);
  LangCombo.Left := WizardForm.WelcomeLabel1.Left;
  LangCombo.Width := WizardForm.WelcomeLabel1.Width;
  LangCombo.Style := csDropDownList;

  SelectLangLabel := TNewStaticText.Create(WizardForm);
  SelectLangLabel.Parent := WizardForm.WelcomePage;
  SelectLangLabel.Top := LangCombo.Top - SelectLangLabel.Height - ScaleY(8);
  SelectLangLabel.Left := LangCombo.Left;
  SelectLangLabel.Caption := SetupMessage(msgSelectLanguageLabel);

  LangCombo.Items.Add('English'); //ItemIndex: 0 - English
  LangCombo.Items.Add('Français'); //ItemIndex: 1 - French
  LangCombo.Items.Add('Deutsch'); //ItemIndex: 2 - German
  LangCombo.Items.Add('Español'); //ItemIndex: 3 - Spanish
  LangCombo.Items.Add('ภาษาไทย'); //ItemIndex: 4 - Thai
  //Add languages as you like, but make sure the order matches the order of the languages in the array.

  SetArrayLength(LangArray,LangCombo.Items.Count);

  LangArray[0] := 'English'; //=ItemIndex: 0
  LangArray[1] := 'French'; //=ItemIndex: 1
  LangArray[2] := 'German'; //=ItemIndex: 2
  LangArray[3] := 'Spanish'; //=ItemIndex: 3
  LangArray[3] := 'Thai'; //=ItemIndex: 4
  //Add languages as you like, but make sure the order matches the order of the languages in the combobox.

  LangCombo.ItemIndex := ActiveLang; //set default language as active language
end;

function NextButtonClick(CurPageID: Integer): Boolean;
var
  ResultCode: THandle;
begin
  Result := True;
  if (CurPageID = wpWelcome) and not IsActiveLang then
  begin
    Result := False;
    IsConfirm := False;
    ResultCode := ShellExecute(0,'',ExpandConstant('{srcexe}'),'/LANG='+LangArray[LangCombo.ItemIndex],'',SW_SHOW);
    if ResultCode <= 32 then MsgBox(Format('Running installer with the selected language failed. Code: %d',[ResultCode]), mbCriticalError, MB_OK);
    WizardForm.Close;
  end;
end;

function ShouldSkipPage(PageID: Integer): Boolean;
begin
  Result := (PageID = wpWelcome) and IsSetLang;
end;

procedure CancelButtonClick(CurPageID: Integer; var Cancel, Confirm: Boolean);
begin
  Cancel := True;
  Confirm := IsConfirm;
end;



[Files]
Source: "MyProg.exe"; DestDir: "{app}"
'Source: "MyProg.chm"; DestDir: "{app}"
'Source: "Readme.txt"; DestDir: "{app}"; Flags: isreadme

[Icons]
Name: "{group}\My Program"; Filename: "{app}\MyProg.exe"
